unit hiPosition;

interface

uses Kol,Share,Debug;

type
  THIPosition = class(TDebug)
   private
    FPos:integer;
   public
    _prop_Target:string;
    _prop_StartPos:integer;
    _prop_ZeroPos:byte;
    _prop_ShortSearch:byte;
    _prop_MethodSearch:byte;

    _data_StartPos:THI_Event;
    _data_Target:THI_Event;
    _data_Str:THI_Event;
    _event_onSearch:THI_Event;

    procedure _work_doSearch0(var _Data:TData; Index:word);
    procedure _work_doSearch1(var _Data:TData; Index:word);
    procedure _work_doSearch2(var _Data:TData; Index:word);        
    procedure _work_doReset(var _Data:TData; Index:word);
    procedure _var_Position(var _Data:TData; Index:word);
  end;

implementation

function PosAsm(const S, SubStr: string; Offset: integer = 1): integer;
{$ifdef F_P}begin{$endif}
asm
        PUSH EDI
        PUSH ESI
        PUSH EBX
        PUSH EAX
        OR EAX,EAX
        JE @@2
        OR EDX,EDX
        JE @@2
        DEC ECX
        JS @@2
        MOV EBX,[EAX-4]
        SUB EBX,ECX
        JLE @@2
        SUB EBX,[EDX-4]
        JL @@2
        INC EBX
        ADD EAX,ECX
        MOV ECX,EBX
        MOV EBX,[EDX-4]
        DEC EBX
        MOV EDI,EAX

@@1:    MOV ESI,EDX
        LODSB
        REPNE SCASB
        JNE @@2
        MOV EAX,ECX
        PUSH EDI
        MOV ECX,EBX
        REPE CMPSB
        POP EDI
        MOV ECX,EAX
        JNE @@1
        LEA EAX,[EDI-1]
        POP EDX
        SUB EAX,EDX
        INC EAX
        JMP @@3

@@2:    POP EAX
        XOR EAX,EAX
        
@@3:    POP EBX
        POP ESI
        POP EDI
end;
{$ifdef F_P}end;{$endif}

function PosABM(const SubStr, S: string; Offset: Integer = 1): Integer; cdecl;
var
  Ps, lp, ls, i : integer;
  BMT: array[Char] of integer;
begin
  ls := Length(S);
  lp := Length(SubStr);

  for i := 0 to 255 do
    BMT[char(i)] := lp;
  for i := 1 to (lp - 1) do
    BMT[SubStr[i]] := lp - i;

  Ps := Offset + lp - 1;

  while Ps <= ls do
    if (SubStr[lp] <> S[Ps]) then
      Ps := Ps + BMT[S[Ps]]
    else
      for i := lp downto 1 do
        if SubStr[i] <> S[Ps - lp + i] then
        begin
          Ps := Ps + BMT[S[Ps]];
          Break;
        end
        else if i = 1 then
        begin
          Result := Ps - lp + 1;
          Exit;
        end;
  Result := 0
end;

procedure THIPosition._work_doSearch0;
var
   Target,Str:string;
begin
   Str := ReadString(_Data,_data_Str,'');
   Target := ReadString(_Data,_data_Target,_prop_Target);
   if (_prop_ShortSearch = 1)or(FPos = 0) then
     FPos := ReadInteger(_Data,_data_StartPos,_prop_StartPos)
   else inc(FPos,Length(Target)); //     

   if FPos <= 0 then FPos := 1; //  

   if (Str <> '')and(Target <> '') then
     FPos := PosEx(Target,Str,FPos)
   else FPos := 0;

   if (_prop_ZeroPos = 0)or( FPos > 0) then
     _hi_CreateEvent(_Data,@_event_onSearch,Fpos);
end;

procedure THIPosition._work_doSearch1;
var
   Target,Str:string;
begin
   Str := ReadString(_Data,_data_Str,'');
   Target := ReadString(_Data,_data_Target,_prop_Target);
   if (_prop_ShortSearch = 1)or(FPos = 0) then
     FPos := ReadInteger(_Data,_data_StartPos,_prop_StartPos)
   else inc(FPos,Length(Target)); //     

   if FPos <= 0 then FPos := 1; //  

   if (Str <> '')and(Target <> '') then
     FPos := PosASM(Str,Target,FPos)
   else FPos := 0;

   if (_prop_ZeroPos = 0)or( FPos > 0) then
     _hi_CreateEvent(_Data,@_event_onSearch,Fpos);
end;

procedure THIPosition._work_doSearch2;
var
   Target,Str:string;
begin
   Str := ReadString(_Data,_data_Str,'');
   Target := ReadString(_Data,_data_Target,_prop_Target);
   if (_prop_ShortSearch = 1)or(FPos = 0) then
     FPos := ReadInteger(_Data,_data_StartPos,_prop_StartPos)
   else inc(FPos,Length(Target)); //     

   if FPos <= 0 then FPos := 1; //  

   if (Str <> '')and(Target <> '') then
     FPos := PosABM(Target,Str,FPos)
   else FPos := 0;

   if (_prop_ZeroPos = 0)or( FPos > 0) then
     _hi_CreateEvent(_Data,@_event_onSearch,Fpos);
end;

procedure THIPosition._work_doReset;
begin
  FPos := 0;
end;

procedure THIPosition._var_Position;
begin
   dtInteger(_Data,FPos);
end;

end.
